Index: /palm/trunk/SOURCE/plant_canopy_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 3743)
+++ /palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 3744)
@@ -22,5 +22,6 @@
 ! Current revisions:
 ! ------------------
-! 
+! Bugfix in transpiration, floating invalid when temperature 
+! becomes > 40 degrees
 ! 
 ! Former revisions:
@@ -236,4 +237,6 @@
 !> 2) Calculation of sinks and sources of momentum, heat and scalar concentration 
 !> due to canopy elements (subroutine pcm_tendency).
+!
+! @todo - precalculate constant terms in pcm_calc_transpiration_rate
 !------------------------------------------------------------------------------!
  MODULE plant_canopy_model_mod
@@ -422,7 +425,7 @@
      sat_press_d = sat_press * 17.27_wp * 237.3_wp / (temp + 237.3_wp)**2
 !--  Wind speed
-     wind_speed = SQRT( ((u(k,j,i) + u(k,j,i+1))/2.0_wp )**2 +           &
-                        ((v(k,j,i) + v(k,j,i+1))/2.0_wp )**2 +           &
-                        ((w(k,j,i) + w(k,j,i+1))/2.0_wp )**2 )
+     wind_speed = SQRT( ( 0.5_wp * ( u(k,j,i) + u(k,j,i+1) ) )**2 +            &
+                        ( 0.5_wp * ( v(k,j,i) + v(k,j,i+1) ) )**2 +            &
+                        ( 0.5_wp * ( w(k,j,i) + w(k,j,i+1) ) )**2 )
 !--  Aerodynamic conductivity (Daudet et al. (1999) eq. 14
      g_b = 0.01_wp * wind_speed + 0.0071_wp
@@ -434,5 +437,5 @@
 !--  Second function for calculation of stomatal conductivity (temperature dependency)
 !--  Stewart (1988; Agric. and Forest. Meteorol. 43) eq. 21
-     f2 = MAX(t2_min, (temp-t2_min) * (t2_max-temp)**((t2_max-16.9_wp)/(16.9_wp-t2_min)) / &
+     f2 = MAX(t2_min, (temp-t2_min) * MAX(0.0_wp,t2_max-temp)**((t2_max-16.9_wp)/(16.9_wp-t2_min)) / &
               ((16.9_wp-t2_min) * (t2_max-16.9_wp)**((t2_max-16.9_wp)/(16.9_wp-t2_min))) )
 !--  Water pressure deficit
Index: /palm/trunk/SOURCE/surface_data_output_mod.f90
===================================================================
--- /palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 3743)
+++ /palm/trunk/SOURCE/surface_data_output_mod.f90	(revision 3744)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Output of waste_heat and innermost wall flux from indoor model
 ! 
 ! Former revisions:
@@ -28,5 +28,5 @@
 ! clean-up coding layout
 ! 
-! 3735 2019-02-12 09:52:40Z dom_dwd_user
+! 3735 2019-02-12 09:52:40Z suehring
 ! - Split initialization into initialization of arrays and further initialization
 !   in order to enable reading of restart data.
@@ -76,5 +76,5 @@
 ! Authors:
 ! --------
-! @author Klaus Ketelsen, Matthias Suehring
+! @author Klaus Ketelsen, Matthias Suehring, Tobias Gronemeier
 !
 ! Description:
@@ -2778,5 +2778,5 @@
 
                ENDIF
-
+               
             CASE ( 'uvw1' )
 !
@@ -2807,5 +2807,64 @@
 
                ENDIF
-
+!
+!--         Waste heat from indoor model
+            CASE ( 'waste_heat' )
+!
+!--            Output of instantaneous data
+               IF ( av == 0 )  THEN
+                  CALL surface_data_output_collect( surf_def_h(0)%waste_heat,  &
+                                               surf_def_h(1)%waste_heat,       &
+                                               surf_lsm_h%waste_heat,          &
+                                               surf_usm_h%waste_heat,          &
+                                               surf_def_v(0)%waste_heat,       &
+                                               surf_lsm_v(0)%waste_heat,       &
+                                               surf_usm_v(0)%waste_heat,       &
+                                               surf_def_v(1)%waste_heat,       &
+                                               surf_lsm_v(1)%waste_heat,       &
+                                               surf_usm_v(1)%waste_heat,       &
+                                               surf_def_v(2)%waste_heat,       &
+                                               surf_lsm_v(2)%waste_heat,       &
+                                               surf_usm_v(2)%waste_heat,       &
+                                               surf_def_v(3)%waste_heat,       &
+                                               surf_lsm_v(3)%waste_heat,       &
+                                               surf_usm_v(3)%waste_heat )
+               ELSE
+!
+!--               Output of averaged data
+                  surfaces%var_out(:) = surfaces%var_av(:,n_out) /             &
+                                        REAL( average_count_surf, KIND=wp )
+                  surfaces%var_av(:,n_out) = 0.0_wp
+
+               ENDIF
+!
+!--         Innermost building wall flux from indoor model
+            CASE ( 'im_hf' )
+!
+!--            Output of instantaneous data
+               IF ( av == 0 )  THEN
+                  CALL surface_data_output_collect( surf_def_h(0)%iwghf_eb,    &
+                                               surf_def_h(1)%iwghf_eb,         &
+                                               surf_lsm_h%iwghf_eb,            &
+                                               surf_usm_h%iwghf_eb,            &
+                                               surf_def_v(0)%iwghf_eb,         &
+                                               surf_lsm_v(0)%iwghf_eb,         &
+                                               surf_usm_v(0)%iwghf_eb,         &
+                                               surf_def_v(1)%iwghf_eb,         &
+                                               surf_lsm_v(1)%iwghf_eb,         &
+                                               surf_usm_v(1)%iwghf_eb,         &
+                                               surf_def_v(2)%iwghf_eb,         &
+                                               surf_lsm_v(2)%iwghf_eb,         &
+                                               surf_usm_v(2)%iwghf_eb,         &
+                                               surf_def_v(3)%iwghf_eb,         &
+                                               surf_lsm_v(3)%iwghf_eb,         &
+                                               surf_usm_v(3)%iwghf_eb )
+               ELSE
+!
+!--               Output of averaged data
+                  surfaces%var_out(:) = surfaces%var_av(:,n_out) /             &
+                                        REAL( average_count_surf, KIND=wp )
+                  surfaces%var_av(:,n_out) = 0.0_wp
+
+               ENDIF
 !
 !--            Add further variables:
@@ -3706,4 +3765,40 @@
                                            surf_lsm_v(3)%uvw_abs,              &
                                            surf_usm_v(3)%uvw_abs, n_out )
+                                           
+            CASE ( 'waste_heat' )
+               CALL surface_data_output_sum_up( surf_def_h(0)%waste_heat,      &
+                                           surf_def_h(1)%waste_heat,           &
+                                           surf_lsm_h%waste_heat,              &
+                                           surf_usm_h%waste_heat,              &
+                                           surf_def_v(0)%waste_heat,           &
+                                           surf_lsm_v(0)%waste_heat,           &
+                                           surf_usm_v(0)%waste_heat,           &
+                                           surf_def_v(1)%waste_heat,           &
+                                           surf_lsm_v(1)%waste_heat,           &
+                                           surf_usm_v(1)%waste_heat,           &
+                                           surf_def_v(2)%waste_heat,           &
+                                           surf_lsm_v(2)%waste_heat,           &
+                                           surf_usm_v(2)%waste_heat,           &
+                                           surf_def_v(3)%waste_heat,           &
+                                           surf_lsm_v(3)%waste_heat,           &
+                                           surf_usm_v(3)%waste_heat, n_out )
+                                           
+            CASE ( 'im_hf' )
+               CALL surface_data_output_sum_up( surf_def_h(0)%iwghf_eb,        &
+                                           surf_def_h(1)%iwghf_eb,             &
+                                           surf_lsm_h%iwghf_eb,                &
+                                           surf_usm_h%iwghf_eb,                &
+                                           surf_def_v(0)%iwghf_eb,             &
+                                           surf_lsm_v(0)%iwghf_eb,             &
+                                           surf_usm_v(0)%iwghf_eb,             &
+                                           surf_def_v(1)%iwghf_eb,             &
+                                           surf_lsm_v(1)%iwghf_eb,             &
+                                           surf_usm_v(1)%iwghf_eb,             &
+                                           surf_def_v(2)%iwghf_eb,             &
+                                           surf_lsm_v(2)%iwghf_eb,             &
+                                           surf_usm_v(2)%iwghf_eb,             &
+                                           surf_def_v(3)%iwghf_eb,             &
+                                           surf_lsm_v(3)%iwghf_eb,             &
+                                           surf_usm_v(3)%iwghf_eb, n_out )
 
          END SELECT
@@ -4161,6 +4256,6 @@
 
        USE control_parameters,                                                 &
-           ONLY:  averaging_interval, dt_data_output, initializing_actions,    &
-                  message_string
+           ONLY:  averaging_interval, dt_data_output, indoor_model,            &
+                  initializing_actions, message_string
 
        USE pegrid,                                                             &
@@ -4293,4 +4388,14 @@
             CASE ( 'r_a', 'r_canopy', 'r_soil', 'r_s' )
                unit = 's/m'
+               
+            CASE ( 'waste_heat', 'im_hf' )
+               IF ( .NOT. indoor_model )  THEN
+                  message_string = TRIM( trimvar ) //                          &
+                             ' requires the indoor model'
+               CALL message( 'surface_data_output_check_parameters',           &
+                             'PA0588', 1, 2, 0, 6, 0 )
+               ENDIF
+            
+               unit = 'W/m2'
 
             CASE DEFAULT
Index: /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90
===================================================================
--- /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 3743)
+++ /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 3744)
@@ -21,5 +21,6 @@
 ! Current revisions:
 ! ------------------
-! 
+! Bugfix, missing calculation of 10cm temperature at vertical building walls, 
+! required for indoor model
 ! 
 ! Former revisions:
@@ -443,7 +444,7 @@
              CALL calc_pt_near_surface ( '2m' )
           ENDIF
-          IF ( indoor_model )  THEN
-             CALL calc_pt_near_surface ( '10cm' )
-          ENDIF
+!
+!--       Calculate 10cm temperature, required in indoor model
+          IF ( indoor_model )  CALL calc_pt_near_surface ( '10cm' )
        ENDIF
 
@@ -548,4 +549,7 @@
 !--          Compute respective surface fluxes for momentum and TKE
              CALL calc_surface_fluxes
+!
+!--          Calculate 10cm temperature, required in indoor model
+             IF ( indoor_model )  CALL calc_pt_near_surface ( '10cm' )
           ENDIF
        ENDDO
@@ -566,4 +570,5 @@
 !--          Compute respective surface fluxes for momentum and TKE
              CALL calc_surface_fluxes
+             
           ENDIF
        ENDDO
@@ -625,4 +630,7 @@
 !--          Compute respective surface fluxes for momentum and TKE
              CALL calc_surface_fluxes
+!
+!--          Calculate 10cm temperature, required in indoor model             
+             IF ( indoor_model )  CALL calc_pt_near_surface ( '10cm' )
           ENDIF
        ENDDO
@@ -2020,9 +2028,9 @@
                 k = surf%k(m)
 
-                surf%pt_10cm(m) = surf%pt_surface(m) + surf%ts(m) / kappa  &
-                                   * ( log( 0.1_wp /  surf%z0h(m) )                    &
-                                  - psi_h( 0.1_wp / surf%ol(m) )                    &
+                surf%pt_10cm(m) = surf%pt_surface(m) + surf%ts(m) / kappa      &
+                                   * ( LOG( 0.1_wp /  surf%z0h(m) )            &
+                                  - psi_h( 0.1_wp / surf%ol(m) )               &
                                      + psi_h( surf%z0h(m) / surf%ol(m) ) )
-
+                                    
              ENDDO
 
@@ -2036,7 +2044,7 @@
                 k = surf%k(m)
 
-                surf%pt_2m(m) = surf%pt_surface(m) + surf%ts(m) / kappa  &
-                                   * ( log( 2.0_wp /  surf%z0h(m) )                    &
-                                     - psi_h( 2.0_wp / surf%ol(m) )                    &
+                surf%pt_2m(m) = surf%pt_surface(m) + surf%ts(m) / kappa        &
+                                   * ( LOG( 2.0_wp /  surf%z0h(m) )            &
+                                     - psi_h( 2.0_wp / surf%ol(m) )            &
                                      + psi_h( surf%z0h(m) / surf%ol(m) ) )
 
Index: /palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/surface_mod.f90	(revision 3743)
+++ /palm/trunk/SOURCE/surface_mod.f90	(revision 3744)
@@ -21,5 +21,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! +waste_heat
 ! 
 ! Former revisions:
@@ -455,4 +455,7 @@
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  rho_c_total       !< volumetric heat capacity of the actual soil matrix (J/m3/K)
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  root_fr           !< root fraction within the soil layers
+       
+!--    Indoor model variables
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  waste_heat          !< waste heat 
 !
 !--    Urban surface variables
@@ -1243,5 +1246,5 @@
 !--    Characteristic temperature and surface flux of sensible heat
        DEALLOCATE ( surfaces%ts )    
-       DEALLOCATE ( surfaces%shf )    
+       DEALLOCATE ( surfaces%shf )
 !
 !--    surface temperature
@@ -1371,5 +1374,5 @@
 !--    Characteristic temperature and surface flux of sensible heat
        ALLOCATE ( surfaces%ts(1:surfaces%ns)  )    
-       ALLOCATE ( surfaces%shf(1:surfaces%ns) )    
+       ALLOCATE ( surfaces%shf(1:surfaces%ns) )
 !
 !--    Surface temperature
@@ -1537,5 +1540,5 @@
 !
 !--    Sensible heat flux
-       DEALLOCATE ( surfaces%shf )    
+       DEALLOCATE ( surfaces%shf )
 !
 !--    Latent heat flux
@@ -1609,5 +1612,5 @@
 !
 !--    Sensible heat flux
-       ALLOCATE ( surfaces%shf(1:surfaces%ns) )    
+       ALLOCATE ( surfaces%shf(1:surfaces%ns) )
 !
 !--    Latent heat flux
@@ -3637,5 +3640,5 @@
              CALL wrd_write_string( 'surf_h(' // dum // ')%sasws' ) 
              WRITE ( 14 )  surf_h(l)%sasws
-          ENDIF     
+          ENDIF
   
        ENDDO
@@ -3781,5 +3784,5 @@
              WRITE ( 14 )  surf_v(l)%mom_flux_tke
           ENDIF 
-
+         
        ENDDO
 
Index: /palm/trunk/SOURCE/time_integration.f90
===================================================================
--- /palm/trunk/SOURCE/time_integration.f90	(revision 3743)
+++ /palm/trunk/SOURCE/time_integration.f90	(revision 3744)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Call indoor model after first timestep
 ! 
 ! Former revisions:
@@ -1413,10 +1413,13 @@
 !--    If required, calculate indoor temperature, waste heat, heat flux
 !--    through wall, etc.
-!--    dt_indoor steers the frequency of the indoor model calculations
+!--    dt_indoor steers the frequency of the indoor model calculations.
+!--    Note, at first timestep indoor model is called, in order to provide
+!--    a waste heat flux. 
        IF ( indoor_model )  THEN
 
           time_indoor = time_indoor + dt_3d
 
-          IF ( time_indoor >= dt_indoor )  THEN
+          IF ( time_indoor >= dt_indoor  .OR.  current_timestep_number == 0 )  &
+          THEN
 
              time_indoor = time_indoor - dt_indoor
